/*
*  PopProfDlg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <assert.h>

#include "PopProfDlg.h"
#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAccProfDlg *AccProfDlg;
//---------------------------------------------------------------------------

AnsiString __fastcall NewAcctProfile(TForm *Owner)
{
   AnsiString profdata;
   AccProfDlg = new TAccProfDlg(Owner);
   CenterDialog(AccProfDlg,Owner);
   AccProfDlg->Top += 6;
   AccProfDlg->ActiveControl = AccProfDlg->AccountUID;
   AccProfDlg->SetProfile("");
   AccProfDlg->ShowModal();
   if (AccProfDlg->ModalResult==mrOk)
      profdata = AccProfDlg->GetProfile();
   delete AccProfDlg;
   return profdata;
}
//---------------------------------------------------------------------------

AnsiString __fastcall EditAcctProfile(TForm *Owner, AnsiString &ProfileStr)
{
   AnsiString profdata;
   AccProfDlg = new TAccProfDlg(Owner);
   CenterDialog(AccProfDlg,Owner);
   AccProfDlg->Top += 6;
   AccProfDlg->ActiveControl = AccProfDlg->AccountUID;
   AccProfDlg->SetProfile(ProfileStr);
   AccProfDlg->ShowModal();
   if (AccProfDlg->ModalResult==mrOk)
      profdata = AccProfDlg->GetProfile();
   delete AccProfDlg;
   return profdata;
}
//---------------------------------------------------------------------------

__fastcall TAccProfDlg::TAccProfDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

AnsiString __fastcall TAccProfDlg::GetProfile()
{
   TStringList *acct = new TStringList();

   acct->Values["account" ] = AccountUID->Text + "@" + Pop3Host->Text;
   acct->Values["password"] = Password->Text;
   acct->Values["remember"] = Remember->Checked ? "1" : "0";
   acct->Values["delete"  ] = Delete->Checked   ? "1" : "0";
   acct->Values["pgponly" ] = PgpOnly->Checked  ? "1" : "0";
   acct->Values["checked" ] = Checked->Checked  ? "1" : "0";

   AnsiString profilestr = acct->CommaText;
   delete acct;

   return profilestr;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetUserID(AnsiString account)
{
   if (account.IsEmpty())
      return "";

   assert(account.Pos("@") > 1);

   AnsiString uid;
   for (int i = account.Length(); i > 1; i--)
   {
      if (account[i] == '@')
      {
         uid = account.SubString(1, i - 1);
         break;
      }
   }

   return uid;
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetPOPHost(AnsiString account)
{
   if (account.IsEmpty())
      return "";

   assert(account.Pos("@") > 1);

   AnsiString pop;
   for (int i = account.Length(); i > 1; i--)
   {
      if (account[i] == '@')
      {
         pop = account.SubString(i + 1, 256);
         break;
      }
   }

   return pop;
}
//---------------------------------------------------------------------------

void __fastcall TAccProfDlg::SetProfile(AnsiString &ProfileStr)
{
   TStringList *acct = new TStringList();
   acct->CommaText = ProfileStr;
   AnsiString item = acct->Values["account"];

   AccountUID->Text  = GetUserID(item);  //GetToken(0, item, "@");
   Pop3Host->Text    = GetPOPHost(item); //GetToken(1, item, "@");

   Password->Text    = acct->Values["password"];
   Remember->Checked = acct->Values["remember"] == "1";
   Delete->Checked   = acct->Values["delete"] == "1";
   PgpOnly->Checked  = acct->Values["pgponly"] == "1";
   Checked->Checked  = acct->Values["checked"] == "1";

   profile = GetProfile();
   delete acct;
}
//---------------------------------------------------------------------------

void __fastcall TAccProfDlg::HideTypeClick(TObject *Sender)
{
   Password->PasswordChar = HideType->Checked ? '*' : '\0';
}
//---------------------------------------------------------------------------

void __fastcall TAccProfDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   switch (ModalResult)
   {
      case mrOk:
         if (AccountUID->Text.IsEmpty())
         {
            MsgBoxHwnd(Handle,"Login ID field required!",
              "Profile Error",MB_OK
            );
            ActiveControl = AccountUID;
            CanClose = false;
            break;
         }
         if (Pop3Host->Text.IsEmpty())
         {
            MsgBoxHwnd(Handle,"POP3 Host field required!",
              "Profile Error",MB_OK
            );
            ActiveControl = Pop3Host;
            CanClose = false;
            break;
         }
         if (Remember->Checked && Password->Text.IsEmpty())
         {
            MsgBoxHwnd(Handle,"You have REMEMBER (password) checked, but no PASSWORD!",
              "Profile Error",
               MB_OK
            );
            ActiveControl = Password;
            CanClose = false;
            break;
         }
         break;

      case mrCancel:
         if (profile!=GetProfile())
         {
            switch(MsgBoxHwnd(Handle,
               "The account data has been modified.\nSave your changes?",
               "Confirm",MB_YESNOCANCEL))
            {
               case ID_YES    : ModalResult = mrOk; break;
               case ID_CANCEL : CanClose = false; break;
               case ID_NO     : break;
            }
         }
   }
}
//---------------------------------------------------------------------------

void __fastcall TAccProfDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("POP3","POP3 Accounts And Features","POP3 Account Profile Dialog",
      this
   );
}
//---------------------------------------------------------------------------
