/*
*  PopRetDlg.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <assert.h>

#include "PopRetDlg.h"
#include "PopPassDlg.h"
#include "PopProfDlg.h"
#include "fileman.h"
#include "global.h"
#include "PrintDlgs.h"
#include "HeadMan.h"
#include "PgpFiles.h"
#include "HelpDlgs.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "Pop3Prot"
#pragma resource "*.dfm"
TPopRetrDlg *PopRetrDlg;
TForm *TheMainForm = NULL;
//---------------------------------------------------------------------------

void __fastcall PopRetrieveMail(TStringList *Accounts, TForm *Owner, TForm *MainForm,
   bool GetUndeleted)
{
   PopRetrDlg = new TPopRetrDlg(Owner);
   CenterDialog(PopRetrDlg,Owner);
   PopRetrDlg->accts = Accounts;
 //PopRetrDlg->MainForm = MainForm;
   PopRetrDlg->getALL = GetUndeleted;
   PopRetrDlg->ShowModal();
   delete PopRetrDlg;
}
//---------------------------------------------------------------------------

__fastcall TPopRetrDlg::TPopRetrDlg(TComponent* Owner)
  : TForm(Owner)
{
   badproxy = false;
   Display->Clear();
   acct = new TStringList();
   uidl = new TStringList();
   msg = new TStringList();
   proxy = new TStringList();

   proxyname = GetAppIni("popproxy", "<none>");
   if (proxyname != "<none>")
   {
      TStringList *proxies = new TStringList();
      GetAppData(proxies, "proxies");

      if (proxies->IndexOf(proxyname) < 0)
      {
         MsgBoxHwnd(this,
            "The socks proxy you have been using '" + GetToken(0, proxyname, ",") + "', has been deleted!\n"
            "You'll need to set your proxy again before continuing.",
            "Warning", MB_OK);
         badproxy = true;
         Cancel = true;
      }
      else
         GetAppData(proxy, "proxies" + PS + proxyname);

      delete proxies;
   }

   Msg = new TMemoryStream();
   lastretrieved = 0;
   totalmails = 0;
   index = -1;

   GetNextMessage();
}
//---------------------------------------------------------------------------

__fastcall TPopRetrDlg::~TPopRetrDlg()
{
   delete Msg;
   delete proxy;
   delete msg;
   delete uidl;
   delete acct;
}
//---------------------------------------------------------------------------

bool __fastcall TPopRetrDlg::GetNextMessage()
{
   PostMessage(Handle,WM_NEXTPOP,0,0L);
   return true;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::LoadAcct(int Index)
{
   assert(Index >= 0 && Index < accts->Count);
   acct->CommaText = accts->Strings[Index];
}
//---------------------------------------------------------------------------

bool __fastcall TPopRetrDlg::Remember()
{
   return acct->Values["remember"]=="1";
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPopRetrDlg::UserId()
{
   AnsiString user, acct = Account();
   assert(acct.Pos("@") > 1);

   for (int i = acct.Length(); i > 1; i--)
   {
      if (acct[i] == '@')
      {
         user = acct.SubString(1, i - 1);
         break;
      }
   }
   assert(user != "");
   return user;
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall TPopRetrDlg::UserId()
{
   AnsiString acct = Account();
   return GetToken(0, acct, "@");
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall TPopRetrDlg::Account()
{
   return acct->Values["account"];
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPopRetrDlg::PopHost()
{
   AnsiString host, hostport, acct = Account();
   assert(acct.Pos("@") > 1);

   for (int i = acct.Length(); i > 0; i--)
   {
      if (acct[i] == '@')
      {
         hostport = acct.SubString(i + 1, acct.Length());
         break;
      }
   }
   host = GetToken(0, hostport, ":");
   assert(host != "");

   return host;
}
//---------------------------------------------------------------------------

/*AnsiString __fastcall TPopRetrDlg::PopHost()
{
   AnsiString acct = Account();
   return GetToken(0, GetToken(1, acct, "@"), ":");
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall TPopRetrDlg::Port()
{
   AnsiString port = GetToken(1, Account(), ":");
   return port.IsEmpty() ? AnsiString("pop3") : port;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPopRetrDlg::Password()
{
   return acct->Values["password"];
}
//---------------------------------------------------------------------------

bool __fastcall TPopRetrDlg::PgpOnly()
{
   return acct->Values["pgponly"]=="1";
}
//---------------------------------------------------------------------------

bool __fastcall TPopRetrDlg::Delete()
{
   return acct->Values["delete"]=="1";
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::DISPLAY(AnsiString &msg)
{
   Display->Lines->Add(msg);
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::WMNextPop(TMessage& Msg)
{
   if (badproxy)
   {
      Snooze(500);
      ModalResult = mrCancel;
      return;
   }
   index++;
   if (index>=accts->Count)
   {
      Finished = true;
      if (totalmails)
      {
         MyBeep(MB_OK);
         TheMainForm->Perform(WM_OPENINBOX,0,NULL);
         Hide(); Application->ProcessMessages();//Sleep(300);
         DISPLAY(s(totalmails)+" messages retrieved");
         ModalResult = mrOk;
         return;
      }
      else
      {
         DISPLAY("No mail");
      }
      StopBtn->Caption = "Ok";
      return;
   }
   GetMailThisAccount(index);
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (badproxy)
      return;
   TheMainForm->Perform(WM_STOREPOPLOG,totalmails,(LPARAM)Display->Lines->Text.c_str());
}
//---------------------------------------------------------------------------

AnsiString __fastcall SocksVer4Sure(const AnsiString &socksver)
{
   AnsiString ver = "4";
   if (socksver == "4a" ||  socksver == "5")
      ver = socksver;
   return ver;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::GetMailThisAccount(int Index)
{
   LoadAcct(Index);
   AnsiString password;

   if (Display->Lines->Count) DISPLAY("");
   DISPLAY("Proxy: " + GetToken(0, proxyname, ","));
   DISPLAY("Connecting to " + PopHost() + "...");
   if (!Remember()) password = GetPopPassword(this,UserId()+"@"+PopHost(),Cancel);
   if (Cancel)
   {
      DISPLAY("Operation cancelled!");
      return;
   }

   POP3->UserName = UserId();
   POP3->Host = PopHost();
   POP3->Port = Port();

   POP3->PassWord = password.IsEmpty() ? Password() : password;

   POP3->CtrlSocket->SocksServer = "";
   POP3->CtrlSocket->SocksPort = "";
   POP3->CtrlSocket->SocksLevel = "4a";
   POP3->CtrlSocket->SocksUsercode = "";
   POP3->CtrlSocket->SocksPassword = "";
   POP3->CtrlSocket->SocksAuthentication = socksNoAuthentication;

//name=TOR
//host=127.0.0.1
//socksver=4a
//pop3=1
//pop3port=9050

   if (proxyname != "<none>")
   {
      AnsiString sockshost, socksport;
      sockshost = proxy->Values["host"];
      socksport = proxy->Values["pop3port"];

      if (!sockshost.IsEmpty() && !socksport.IsEmpty())
      {
         POP3->CtrlSocket->SocksServer = sockshost;
         POP3->CtrlSocket->SocksPort = socksport;
         POP3->CtrlSocket->SocksLevel = SocksVer4Sure(proxy->Values["socksver"]);

         if (proxy->Values["auth"] == "1")
         {
            POP3->CtrlSocket->SocksUsercode = proxy->Values["userid"];
            POP3->CtrlSocket->SocksPassword = proxy->Values["password"];
            POP3->CtrlSocket->SocksAuthentication = socksAuthenticateUsercode;
         }
      }
   }

   POP3->Connect();
}
//---------------------------------------------------------------------------

/*void __fastcall TPopRetrDlg::GetMailThisAccount(int Index)
{
   LoadAcct(Index);
   AnsiString password;

   if (Display->Lines->Count) DISPLAY("");
   DISPLAY("Proxy: " + GetToken(0, proxyname, ","));
   DISPLAY("Connecting to " + PopHost() + "...");
   if (!Remember()) password = GetPopPassword(this,UserId()+"@"+PopHost(),Cancel);
   if (Cancel)
   {
      DISPLAY("Operation cancelled!");
      return;
   }

   POP3->UserName = UserId();
   POP3->Host = PopHost();
   POP3->Port = Port();
   POP3->PassWord = password.IsEmpty() ? Password() : password;

   POP3->CtrlSocket->SocksServer = "";
   POP3->CtrlSocket->SocksPort = "";
   POP3->CtrlSocket->SocksLevel = "4a";
   POP3->CtrlSocket->SocksUsercode = "";
   POP3->CtrlSocket->SocksPassword = "";
   POP3->CtrlSocket->SocksAuthentication = socksNoAuthentication;

//name=TOR
//host=127.0.0.1
//socksver=4a
//pop3=1
//pop3port=9050

   if (proxyname != "<none>")
   {
      AnsiString sockshost, socksport;
      sockshost = proxy->Values["host"];
      socksport = proxy->Values["pop3port"];

      if (!sockshost.IsEmpty() && !socksport.IsEmpty())
      {
         POP3->CtrlSocket->SocksServer = sockshost;
         POP3->CtrlSocket->SocksPort = socksport;
         POP3->CtrlSocket->SocksLevel = SocksVer4Sure(proxy->Values["socksver"]);

         AnsiString socksuser, sockspswd;
         socksuser = proxy->Values["userid"];
         sockspswd = proxy->Values["password"];

         if (!socksuser.IsEmpty() && !sockspswd.IsEmpty())
         {
            POP3->CtrlSocket->SocksUsercode = socksuser;
            POP3->CtrlSocket->SocksPassword = sockspswd;
            POP3->CtrlSocket->SocksAuthentication = socksAuthenticateUsercode;
         }
      }
   }

   POP3->Connect();
}*/
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3Display(TObject *Sender, AnsiString Msg)
{
   DISPLAY(Msg);
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3RequestDone(TObject *Sender,
  TPop3Request RqType, WORD Error)
{
   if (Cancel) return;
   if (Error)
   {
      AnsiString errmsg = POP3->ErrorMessage;
      if (errmsg.IsEmpty())
         errmsg = WSocketErrorDesc(Error);
      DISPLAY("Error: " + IntToStr(Error) + " " + errmsg);
      StopBtn->Caption = "Ok";
      return;
   }
   static bool statnomail=false;
   char *MsgMem = (char*)Msg->Memory;
   AnsiString fname,pgpline,datakey,nixmsg,winmsg,lr=POP3->LastResponse;
   switch (RqType)
   {
      case pop3Connect:
         DISPLAY("Logging in to POP Server");
         POP3->User();
         break;
      case pop3User:
         DISPLAY(" USER "+lr);
         POP3->Pass();
         break;
      case pop3Pass:
         DISPLAY(" PASS "+lr);
         if (PgpOnly()) DISPLAY(" RETR Retrieving only PGP mail");
         POP3->Stat();
         break;
      case pop3Stat:
         DISPLAY(" STAT "+lr);
         POP3->MsgNum = 0;
         if (GetParam(1,lr," ")=="0")
         {
            statnomail = true;
            POP3->Noop();
            break;
         }
         POP3->Uidl();
         break;
      case pop3Uidl:
         POP3->MsgNum = getALL ? 0:lastretrieved;
         DISPLAY(" UIDL +OK "+lr);
      case pop3Noop:
         if (POP3->MsgNum >= POP3->MsgCount)
         {
            POP3->Quit();
            break;
         }
         POP3->MsgNum++;
         POP3->List();
         break;
      case pop3List:
         DISPLAY(" LIST "+lr);
         POP3->MsgNum = GetParam(1,lr," ").ToIntDef(0);
         BytesTotal = GetParam(2,lr," ").ToIntDef(0);
         if (PgpOnly())
         {
            DISPLAY(" RETR "+AnsiString((int)POP3->MsgNum)+"...");
            POP3->MsgLines = 4;
            POP3->Top();
            break;
         }
         totalmails++;
         DISPLAY(" RETR Retreiving Message "+AnsiString((int)POP3->MsgNum));
         POP3->Retr();
         break;
      case pop3Retr:
         Msg->Write("\0",1);
         TheMainForm->Perform(WM_INCOMINGMAIL,0,(LPARAM)Msg->Memory);
         Msg->SetSize(0);
         if (Delete())
         {
            POP3->Dele();
            break;
         }
         POP3->Noop();
         break;
      case pop3Dele:
         DISPLAY(" DELE "+lr.SubString(5,32));
         POP3->Noop();
         break;
      case pop3Top:
         if (Msg->Size)
         {
            Msg->Write("\0",1);
            int lastline = Display->Lines->Count-1;
            if (PgpOnly())
            {
               winmsg = "\r\n" + BeginPgpMessage + "\r\n";
               if (strstr(MsgMem, winmsg.c_str()))
               {
                //Display->Lines->Strings[lastline] = " RETR " + AnsiString((int)POP3->MsgNum) + " yes";
                  Application->ProcessMessages();
                  Display->Lines->Strings[lastline] = " RETR " + AnsiString((int)POP3->MsgNum) + " Retrieving PGP message";
                  totalmails++;
                  POP3->Retr();
                  break;
               }
               Display->Lines->Strings[lastline] = " RETR " + AnsiString((int)POP3->MsgNum) + " no";
            }
            else
            {
               totalmails++;
               Display->Lines->Strings[lastline] = " RETR Retreiving Message " + AnsiString((int)POP3->MsgNum);
               POP3->Retr();
               break;
            }
         }
         POP3->Noop();
         break;
      case pop3Quit:
         if (!statnomail && CurTime < TimeOut)
            PutLastMessageId(Account(), GetParam(1, uidl->Strings[lastretrieved], " "));
         DISPLAY("Connection closed!");
         while (POP3->Connected && !Application->Terminated)
            AppProcessMessages();
         GetNextMessage();
         break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3MessageBegin(TObject *Sender)
{
   Msg->SetSize(0);
   //msg->Clear();
   ProgressBar->Min = 0;
   ProgressBar->Max = 100;
   ProgressBar->Position = 0;
   ProgressBar->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3MessageLine(TObject *Sender)
{
   LastResponse = POP3->LastResponse;
   Msg->Write(s(LastResponse+"\r\n").c_str(),LastResponse.Length()+2);
   if (BytesTotal!=0)
      ProgressBar->Position = (double)(Msg->Size/BytesTotal)*100;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3MessageEnd(TObject *Sender)
{
   lastretrieved = POP3->MsgNum;
   ProgressBar->Position = 100;
   Sleep(100);
   ProgressBar->Position = 0;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::FormResize(TObject *Sender)
{
   StopBtn->Left = Width - 113;
   ProgressBar->Width = Width - 144;
   Display->SelStart = 0;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::StopBtnClick(TObject *Sender)
{
   if (StopBtn->Caption=="Stop")
   {
      if (!Finished)
      {
         DISPLAY("Operation cancelled!");
         Display->Perform(EM_LINESCROLL,0,(LPARAM)1);
         StopBtn->Caption = "Ok";
         MyBeep(MB_ICONHAND);
         Cancel = true;
      }
   }
   else
      ModalResult = Cancel ? mrCancel:mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3UidlBegin(TObject *Sender)
{
   uidl->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3UidlLine(TObject *Sender)
{
   uidl->Add(POP3->LastResponse);
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::POP3UidlEnd(TObject *Sender)
{
   lastretrieved = uidl->Count;
   AnsiString msgid = GetLastMessageId(Account());
   // insert the retrieved msgid into list at top so we'll definately get a match
   // working from bottom to top
   if (uidl->Count) uidl->Insert(0,"0 "+msgid); else uidl->Add("0 "+msgid);
   while (GetParam(1,uidl->Strings[lastretrieved]," ")!=msgid)
      lastretrieved--;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TPopRetrDlg::GetLastMessageId(AnsiString &account)
{
   TStringList *ids = new TStringList();
   ids->SetText((char*)TheMainForm->Perform(WM_DATREQUEST,GetDatData,(long)PopLastMsgId.c_str()));
   AnsiString msgid = ids->Values[Account()];
   delete ids;
   return msgid;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::PutLastMessageId(AnsiString &account, AnsiString &msgid)
{
   TStringList *ids = new TStringList();
   ids->SetText((char*)TheMainForm->Perform(WM_DATREQUEST, GetDatData, (long)PopLastMsgId.c_str()));
   ids->Values[Account()] = msgid;
   ids->Insert(0, PopLastMsgId); // pass PutAppData path with stringlist of data
   TheMainForm->Perform(WM_DATREQUEST, PutDatData, (long)ids->Text.c_str());
   delete ids;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::PopCopyItemClick(TObject *Sender)
{
   Display->CopyToClipboard();
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::PopPrintItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Sent this transcript to the printer?","Confirm",MB_OKCANCEL)==IDOK)
     PrintMessage(Display->Lines,Display->Font,"QuickSilver POP3 Transcript",this);
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::PopupMenu1Popup(TObject *Sender)
{
   PopCopyItem->Enabled = Display->SelLength>0;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp2("POP3_Errors Retrieving Mail","I can't get my mail!","");
}
//---------------------------------------------------------------------------


