/*
*  console.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef ConsoleH
#define ConsoleH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <time.h>
//---------------------------------------------------------------------------
int __fastcall RunConsoleApp(const AnsiString &Cmdline, TStrings *Output,
   WORD ShowCmd=SW_MINIMIZE, bool *Cancel=NULL,
   TProgressBar *ProgressBar=NULL
);

class TConsoleApp
{
private:
   WORD showcmd;
   AnsiString cmdline;
   bool __fastcall readfile(HANDLE hReadPipe);
public:
   TStrings *output;
   bool *cancel;
   bool timeout;
   bool creatpipe;   // createpipe success
   bool creatproc;   // createprocess success
   DWORD exitwait;   // waitforsingleobject: WAIT_ABANDON, WAIT_OBJECT_0, WAIT_TIMEOUT
   bool exitproc;    // getexitcodeproc success
   DWORD exitcode;   // this is the exec'd programs exit code
   TProgressBar *progressbar;
   __fastcall TConsoleApp(const AnsiString &Cmdline, TStrings *Output, WORD ShowCmd);
   __fastcall ~TConsoleApp();
   long __fastcall Run();
};

//---------------------------------------------------------------------------
extern TConsoleApp *ConsoleApp;
//---------------------------------------------------------------------------
#endif
